#!/usr/bin/python

#   Copyright (C) 2002 Yannick Gingras <ygingras@ygingras.net>
#   Copyright (C) 2002 Vincent Barbin <vbarbin@openbeatbox.org>

#   This file is part of Open Beat Box.

#   Open Beat Box is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation; either version 2 of the License, or
#   (at your option) any later version.

#   Open Beat Box is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.

#   You should have received a copy of the GNU General Public License
#   along with Open Beat Box; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


from qt import *
from OBBButton import OBBButton
from PixmapSet import *

class PushButton(OBBButton):
    def __init__(self, pixmapSet, parent=None, x=0, y=0):
        OBBButton.__init__(self, pixmapSet, parent, x, y)
        self.pendingMouseEvent = 0
        self.connect( self,
                      PYSIGNAL("beingReleased(e)"),
                      self.processRelease )

    def dropMouseCapture(self):
        self.toggleState()
        self.pendingMouseEvent = 0
    
    def processClick(self, e):
        self.pendingMouseEvent = 1
        self.captureMouse(self.dropMouseCapture)
        self.toggleState()

    def processRelease(self, e):
        if self.pendingMouseEvent:
            self.emit(PYSIGNAL("clicked()"), ())
        
